; password.asm- Password login manager for DOS based systems
; ------------- (c) Chris Evans 2005 gryphonphyre@gamebox.net  1-916-501-1423
; Program query user at console for username and if found prompts for
; assigned password, returns NZ errorlevel if success. Program behaves alike
; a linux/unix login.
; ---------------------------------------------------------------------------
; TO-DO:
;
; [ ] Checksum of user password.
; [ ] one file instead of multiple files (e.g. user.dat)
; 
; ---------------------------------------------------------------------------

LOGINRETRIES    equ 3

code            segment byte public
                assume  cs:code, ds:code
		org	100h
password        proc    far

start:          jmp     main
include         toolbox.asm
                _compile
                _argc dw ?
main:
                mov  bh, '/'
                mov  bl, '?'
                call scancmdline
                mov  _argc, cx
                or   cx, cx
                jz   _noparams
                cmp  dl, 1
                jl   _noparams
                _print help_msg, 1
                jmp  exit
_noparams:
                mov  cx, LOGINRETRIES
_main1:
                call cs:login
                cmp  al, 0
                ja   exit
                loop _main1
exit:           call dosexit
password        endp

; ===========================================================================
login           proc far
; ===========================================================================
                push cx

                _print username, 1
                lea  di, input
                mov  cx, i
                call getdata
                _newline

                _fileexist input
                jc _openexisting
                ; _openfile input, 1, 0
                ; mov  handle, ax
                ; _writefile handle, pwdefault, 0ah
                ; _writefile handle, pwtrailer, 0ah
                ; _closefile handle
                ; _print invalidusername, 1 
                mov al, 0h
                jmp _lext
_openexisting:
                _openfile input, 0, 0
                mov  handle, ax
                call freadln                ; BX:SI CX
                move i, cx
                mov  j, si
                mov  k, bx
                _closefile handle

               ; _print _buffer, 1
               ; _newline


                _print pwmsg, 1
                lea  di, input
                mov  cx, i
                call getdata
                _newline

               ; _print _buffer, 1
               ; _newline

                push es
                mov  ax, k
                mov  es, ax
                lea  di, input
                lea  si, _buffer
                mov  cx, i
                mov  dl, 0ah
                call compare
                pop  es
                mov  ax, bx
                or   ax, ax
                jz   _passok
                _print wrongpw, 1
                mov  al, 0
                jmp  _lext
_passok:        _print rightpw, 1
                mov  al, 1
_lext:          pop cx
                ret
login           endp

handle          dw 0
username        db 'login: ',0
pwmsg           db 'password: ',0
wrongpw         db 'Wrong password entered.',0ffh,0
invalidusername db 'Invalid username.',0ffh,0
rightpw         db 'Password is correct.',0ffh,0
pwdefault       db 'password',0dh,0ah,0
pwtrailer       db '; ---------------------------------------------',0dh,0ah,0
input           db 255 dup(0)
i               dw ?
j               dw ?
k               dw ?
help_msg        db 'Password Manager (c) 2005 Chris Evans; gryphonphyre@bluebottle.com',0ffh,0ffh
                db '/add ................................ Adds a user to database',0ffh
                db '/del ................................ Deletes a user from database',0ffh
                db '/reset .............................. Reset database',0ffh,0

code            ends

ProgramEnd      EQU $-01h

		end	start
