; MAR - 7 - 2006 : DMA.ASM direct memory chip support

EnableDMA proc far
;-----------------------------------------------------------------------------
; EnableDMA: enable DMA controller
;-----------------------------------------------------------------------------
; in:  nothing
; out: nothing
;-----------------------------------------------------------------------------
  mov al, 00010000b
  out 08h, al ; enable master
  out 0D0h, al ; enable slave
  ret
EnableDMA endp

DisableDMA proc far
;-----------------------------------------------------------------------------
; DisableDMA: disable DMA controller
;-----------------------------------------------------------------------------
; in:  nothing
; out: nothing
;-----------------------------------------------------------------------------

  mov al, 00010100b
  out 08h, al ; disable master
  out 0D0h, al ; disable slave

  ret
DisableDMA endp



UnmaskDMAChannel proc far
;-----------------------------------------------------------------------------
; UnmaskDMAChannel: unmask (enable) DMA channel
;-----------------------------------------------------------------------------
; in:  bl = channel number
; out: nothing
;-----------------------------------------------------------------------------

  cmp bl, 3 ; IF channel > 3...
  ja slave_dma ; ...THEN slave DMA channel

  ; unmask master DMA channel
  mov al, bl ; al = channel
  out 0Ah, al ; unmask channel
  jmp udma_end

  ; unmask slave DMA channel
slave_dma:
  and bl, 00000011b ; bl = slave channel
  mov al, bl ; al = slave channel
  out 0D4h, al ; unmask channel

udma_end:
  ret
UnmaskDMAChannel endp

MaskDMAChannel proc far
;-----------------------------------------------------------------------------
; MaskDMAChannel: mask (disable) DMA channel
;-----------------------------------------------------------------------------
; in:  bl = channel number
; out: nothing
;-----------------------------------------------------------------------------
  cmp bl, 3 ; IF channel > 3...
  ja mdma_slave_dma ; ...THEN slave DMA channel

  ; mask master DMA channel
  mov al, bl ; al = channel
  or al, 00000100b
  out 0Ah, al ; mask channel
  jmp mdma_end

  ; mask slave DMA channel
mdma_slave_dma:
  and bl, 00000011b ; bl = slave channel
  mov al, bl ; al = slave channel
  or al, 00000100b
  out 0D4h, al ; mask channel

mdma_end:
  ret
MaskDMAChannel endp


