; FREEBSD defines for NXDOS kernel 6/16/2006
;       FreeBSD questions : questions@FreeBSD.org
;       ftp://ftp.freebsd.org/pub/FreeBSD/doc/
; My goal with this is to have NXDOS to be somewhat freebsd compatible.

BSD_KERNEL EQU 80h         ; int 80h

IF (LINUX)
        SYS_EXECVE EQU 11
ELSE
        SYS_EXECVE EQU 59
ENDIF

; Symbolic BSD functions
SYS_NOSYS EQU 0
SYS_EXIT  EQU 1
SYS_FORK  EQU 2
SYS_READ  EQU 3
SYS_WRITE EQU 4

bsdmode  dd ?
bsdflags dd ?
bsdpath  dd ?

unix macro bsd_function
       .386p
IF (LINUX)
       nop
ELSE
       mov  eax, bsd_function
ENDIF
       call unixkernel
       .286
;       ret
       endm

; ===========================================================================
int80 proc far  ; INT80H
; ===========================================================================
        call cs:bsd
        iret
bsd proc far

        ret
bsd endp
int80 endp

unixkernel proc far
.386p
IF (LINUX)
       push ebx
       push ecx
       push edx
       push esi
       push edi
       push ebp
       mov  ebx, [esp+32]
       mov  ecx, [esp+36]
       mov  edx, [esp+40]
       mov  esi, [esp+44]
       mov  ebp, [esp+48]
       int  BSD_KERNEL
       pop  ebp
       pop  edi
       pop  esi
       pop  edx
       pop  ecx
       pop  ebx
ELSE
sysexit:

       jmp  short sys_ret
sysopen:

       jmp  short sys_ret
sysclose:
       ; one param funcs
       ; push ebx
       ; mov  ebx, [esp+12]
bsdkernel:
       int  BSD_KERNEL
ENDIF
sys_ret:
       or   eax, eax
       js   sysv_err
       clc
       ret
sysv_err:
       neg  eax
       stc
.286
       ret
unixkernel endp

; ===========================================================================
fork proc far
; AX = NONE
; ===========================================================================

     ret
fork endp

; ===========================================================================
bsdwait proc far
; AX = NONE
; ===========================================================================

     ret
bsdwait endp

; ===========================================================================
execl proc far
; AX = NONE
; ===========================================================================

     ret
execl endp

; ===========================================================================
execlp proc far
; AX = NONE
; ===========================================================================

     ret
execlp endp

; ===========================================================================
execlv proc far
; AX = NONE
; ===========================================================================

     ret
execlv endp

; ===========================================================================
execvp proc far
; AX = NONE
; ===========================================================================

     ret
execvp endp

; ===========================================================================
bsdexit proc far
; AX = NONE
; ===========================================================================

     ret
bsdexit endp

; ===========================================================================
signal proc far
; AX = SIG
; BX = HANDLER
; ===========================================================================

     ret
signal endp

; ===========================================================================
kill proc far
; AX = SIG
; BX = HANDLER
; ===========================================================================

     ret
kill endp

; ===========================================================================
pipe proc far
; AX = FILDES
; ===========================================================================

     ret
pipe endp

; ===========================================================================
bsddup proc far
; AX = FD
; ===========================================================================

     ret
bsddup endp

creat proc far

     ret
creat endp

bsdopen proc far
.386p
     push    dword bsdmode
     push    dword bsdflags
     push    dword bsdpath
     mov     eax, 5
     call    bsd
     add     esp, 12
.286c
     ret
bsdopen endp

bsdclose proc far
     ret
bsdclose endp

unlink proc far

     ret
unlink endp

bsdread proc far

     ret
bsdread endp

bsdwrite proc far

     ret
bsdwrite endp

lseek proc far

     ret
lseek endp

vm86 proc far

     ret
vm86 endp

; acct adjtimex bdflush capget capset create_module delete_module
; get_kernel_syms init_module mount nfsservctl old_umount old_vm86
; pivot_root prctl Ptrace query_module quotactl reboot sendfile setdomainname
; setfsuid setfsuid16 setfsgid setfsgid16 sethostname sigqueueinfo
; swapoff swapon sysfs sysinfo syslog umount uselib ustat vhangup vm86

; ===========================================================================
bsd_exit proc far
; ===========================================================================
        unix SYS_EXIT
	ret
bsd_exit endp

; ===========================================================================
bsd_fork proc far
; ===========================================================================
        unix SYS_FORK
	ret
bsd_fork endp

; ===========================================================================
bsd_read proc far
; ===========================================================================
        unix SYS_READ
	ret
bsd_read endp

; ===========================================================================
bsd_write proc far
; ===========================================================================
        unix SYS_WRITE
	ret
bsd_write endp
