Message #77 - 80xxx Assembly 
   Date: 01-23-97 10:22:00
   From: Erik Terpstra
     To: All
Subject: Linear addressing for S3 SVGA-cards.
-------------------------------------------------------------------------------
@MSGID: 2:282/500.0 32e7889b
@PID: BWRA 3.11 [Eval]
@PATH 282/500 1 123 280/801 270/101 203/992 3333 996
Hello All,

For the lucky ones who own a SVGA card with S3 chipset.

Of course you'll have to switch to protected mode first.
Cirrus Logic and ET4000 examples will follow.

I am writing a freeware 32-bits linear dynamically linked graphics library,
for more info you can contact me at: e.r.terpstra@st.hanze.nl.




;
; S3.ASM
; Linear addressing of video memory for S3 chipsets.
; Freeware, Erik Terpstra 1996.
; e.r.terpstra@st.hanze.nl
; Use at own risk!


;

CODE	SEGMENT PUBLIC
	ASSUME CS:CODE
	EXTRN flat_INSTALL:NEAR,flat_DESTALL:NEAR
	ORG 100H
	.386

; DECLARATIONS


	CR EQU 03D4H		;Control registers
	
; MODULE


Main:
	CALL flat_INSTALL	;Install protected/unreal mode
	XOR AX,AX
	MOV ES,AX		;ES=0
	MOV DS,AX

	MOV BX,0101H		;Screen=640*480*256
	CALL SetMode

	MOV AH,640/4/2		;Screen width=640
	CALL SetWidth

	CALL Unlock		;Unlock the S3 registers
	CALL EnhancedMode	;Enables base address offset
	CALL LinearMode		;No bank switching :-)
	CALL ReadAheadMode
	CALL FastWriteMode

	MOV EAX,1		;Color
	CALL ClearScreen
				;WaitAnyKey
	MOV AH,01H
	INT 21H

	CALL FLAT_destall
				;Mode CO80
	MOV AX,0003H
	INT 10H
				;DOS Exit
	MOV AX,4C00H
	INT 21H

; PROCEDURE


EnhancedMode:
	MOV DX,CR
	MOV AL,31H		;S3-CR31 Memory Configuration Register
	OUT DX,AL
	INC DX
	IN AL,DX
	MOV AH,AL
	OR AH,09H

	DEC DX
	MOV AL,31H		;S3-CR31 Memory Configuration Register
	OUT DX,AL
	INC DX
	MOV AL,AH
	OUT DX,AL
	RET

; PROCEDURE


FastWriteMode:
	MOV DX,CR
	MOV AL,40H
	OUT DX,AL
	INC DX
	IN AL,DX
	OR AL,08H
	MOV BL,AL

	DEC DX
	MOV AL,40H
	OUT DX,AL
	INC DX
	MOV AL,BL
	OUT DX,AL
	RET

; PROCEDURE


LinearMode:
	MOV DX,CR
	MOV AL,58H		;S3 Linear Address Window Control Register
	OUT DX,AL
	INC DX
	IN AL,DX
	MOV AH,AL
	AND AH,0ECH

	DEC DX
	MOV AL,58H		;S3 Linear Address Window Control Register
	OUT DX,AX
	INC DX
	MOV AL,AH
	OUT DX,AX

	DEC DX
	MOV AL,59H		;S3 Linear Address Window Position Register
	OUT DX,AL
	INC DX
	MOV AL,03H
	OUT DX,AL

	DEC DX
	MOV AL,5AH		;S3 ??
	OUT DX,AX
	INC DX
	MOV AL,00H
	OUT DX,AX

	DEC DX
	MOV AL,58H		;S3 Linear Address Window Control Register
	OUT DX,AL
	INC DX
	IN AL,DX
	MOV AH,AL
	OR AH,11H

	DEC DX
	MOV AL,58H		;S3 Linear Address Window Control Register
	OUT DX,AL
	INC DX
	MOV AL,AH
	OUT DX,AL
	RET

; PROCEDURE


ReadAheadMode:
	MOV DX,CR
	MOV AL,58H
	OUT DX,AL
	INC DX
	IN AL,DX
	AND AL,0FBH
	MOV BL,AL

	DEC DX
	MOV AL,58H
	OUT DX,AL
	INC DX
	MOV AL,BL
	OUT DX,AL
	
	DEC DX
	MOV AL,54H
	OUT DX,AX
	INC DX

	MOV AX,1
	AND AX,07H
	OUT DX,AL

	DEC DX
	MOV AL,58H
	OUT DX,AL
	INC DX
	OR BL,04H
	MOV AL,BL
	OUT DX,AL
	RET

; PROCEDURE


SetWidth: ;(width:AH)
	MOV DX,CR
	MOV AL,13H		;VGA Offset Register
	OUT DX,AL
	INC DX
	MOV AL,AH
	OUT DX,AL
	RET

; PROCEDURE


Unlock:
	MOV DX,CR
	MOV AL,38H		;S3-CR38 Register Lock 1
	OUT DX,AL
	INC DX
	MOV AL,48H
	OUT DX,AL

	DEC DX
	MOV AL,39H		;S3-CR39 Register Lock 2
	OUT DX,AL
	INC DX
	MOV AL,0A0H
	OUT DX,AL
	RET

; EXPORT PROCEDURE


ClearScreen: ;(color:EAX)
	MOV EDI,03000000H	;32-bits screen offset
	MOV ECX,(640*480)/4	;Number of bytes to fill screen

	MOV EDX,EAX
	SHL EDX,8
	OR EDX,EAX
	SHL EDX,8
	OR EDX,EAX
	SHL EDX,8
	OR EDX,EAX
Fill:
	MOV DWORD PTR ES:[EDI],EDX
	ADD EDI,4
	DEC ECX
	JNZ Fill
	RET

; EXPORT PROCEDURE


SetMode: ;(mode:BX)
	MOV AX,4F02H		;Set VESA SuperVGA mode
	INT 10H
	RET

; ENDMODULE


CODE	ENDS
	END Main


... Scotty !, Beam me Aaarghh$%^&##... NO CARRIER
--- HIO-BBS Groningen
 * Origin: HIO-BBS Groningen (+31)50-712756 (2:282/500)
