; Copyright 2004-2005 Christopher Evans
; email:   tekno1911@yahoo.com
; Website: http://nxdos.sourceforge.net/
;                                                                           ;
;       This program is copyrighted, but may be freely distributed          ;
;       under the terms of the Free Software Foundation's GNU General       ;
;       Public License v2 (or later.)  See the file COPYING for the         ;
;       legalities.  If you did not receive a copy of COPYING, you          ;
;       may request one from the Free Software Foundation, Inc.,            ;
;       59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.           ;
;       ABSOLUTELY NO WARRANTY -- use it at your own risk!                  ;
;                                                                           ;

_stack     segment word stack 'STACK'
           db      0100h DUP (05h)
_stack     ends

data segment
titles     db 'NXDOS SETUP Installer (c) Christopher R. Evans 1996-2007',0ffh,0
helptext   db 'SETUP Installs MiniFreedos or NXDOS (automatic)',0ffh
           db '      [drive:] ',0ffh
           db '      ',0
setuptitle db 'NX-DOS                 - Setup',0
setupline  db '',0
menubar    db '                        F2 = FreeDos, F3 = FDISK, F4 = FORMAT [x:]',0
oldmsg     db '       Sorry, but, NX-DOS requires atleast a 286 or better.',0ffh,0ffh
           db '       System requirements: ',0ffh
           db '              o 200Mhz Intel or AMD 32bit CPU with 1Mb RAM.',0ffh
           db '              o CD-ROM and Floppy disk drive.',0ffh
           db '              o VESA SVGA adapter supporting 320x200 MODE-X Graphics.',0ffh,0
intro      db '       This installer will write a copy of the boot images to the target disk',0ffh
           db ' and configure the system for your computer type. If you wish to contine with',0ffh
           db ' installation then press "ENTER" now or press ESC to exit to DOS.',0ffh,0ffh
           db '       SETUP will be completed when I have time, since I am currently focused',0ffh
           db ' on getting the kernel to work as it should.',0ffh,0
cpuisok    db '       Your computer meets minimal requirements for install.',0
frdoswel   db 'Welcome to the MINI-'
frdosmsg   db 'FreeDOS Installer',0
frdosmnu   db 'This program will help you install FreeDOS.',0ffh,0ffh,0ffh
           db '                             1) DRIVE: ',0ffh
           db '                             2) PATH : ',0ffh,0ffh
           db '                             I) Begin install',0ffh
           db 0
fdoslzh    db 'mfd\fdos.lzh',0
argc       dw ?
handle     dw 00h
drive      db  0  ; 0 = a:, 1 = b:
imgfile    db 'a.img',0
           db 128 dup(?)
truename   db 128 dup(?)
Buffer     db 512*18*2 dup(?)
include \nxdos\src\tbx_data.inc
data ends

setup  segment
       assume cs:setup, ds:data, es:data, ss:_stack

include \nxdos\src\tbx_code.inc
include \nxdos\src\kernel\nxdos.equ
       
start:  mov  ax, data    
        mov  ds, ax      
        mov  es, ax

     _print titles, 1
     mov  bh, '/'
     mov  bl, '?'
     call scancmdline
     mov  argc, cx
     cmp  al, 1
     je   showhelp
          call cs:main
          jmp  exit
showhelp:
     call cs:help
exit:
     call dosexit

help proc far
     _print helptext, 1
     ret
help endp

checkhardware proc far
        call checkcpu
        cmp  ax, 2
        jb   hware_bad

        ; check for other things... blah blah

hware_ok:
        clc
        jmp  short hwarex
hware_bad:
        stc
hwarex:
        ret
checkhardware endp

setup_screen proc
        _gotoxy 1,1,0
        _textcolor YELLOW, BLUE
        call clrscr
        _gotoxy 1, 25, 0
        _textcolor YELLOW, CYAN
        call clreol
        _gotoxy 1, 25, 0
        _print menubar, 1
        _gotoxy 1,1,0
        _textcolor YELLOW, BLUE
        _print setuptitle, 1

        _gotoxy 8, 1, 0
        mov  ax, _dosversion
        call wrdec
        _echo ' '
        _echo '('
        mov  ax, _version
        call wrdec
        _echo '.'
        mov  al, _revision
        call putnum
        _echo '.'
        mov  al, _maintenance
        call putnum
        _echo '.'
        mov  al, _build
        call putnum
        _echo ')'

        _newline
        _textcolor HICYAN, BLUE
        _print setupline, 1
        ret
setup_screen endp

; ===========================================================================
frdos proc far
; ===========================================================================
      _fileexist fdoslzh
      jnc  short nofrdos
           call  cs:minifreedos
frdos1:
      stc
      jmp  short frdosx
nofrdos:
      clc
frdosx:
      ret
; ===========================================================================
minifreedos proc far
; ===========================================================================
         call cs:mfrdosintro
         _textcolor GRAY, BLUE
         _gotoxy 12, 10, 0
         _print frdoswel, 1
         _gotoxy 12, 11, 0
         _print  frdosmnu, 1

         _gotoxy 23, 10, 0

         call readkey

         ;gotoxy(12,13); cprintf(" 1) DRIVE: %c:\\",drive);
         ;gotoxy(12,14); cprintf(" 2) PATH : %s",path);
         ;gotoxy(12,15); cprintf(" I) Install");
         ;gotoxy(12,16); cprintf(" Q) Quit");
         ;gotoxy(12,17);

         ; textbackground(1);

      ret
minifreedos endp
mfrdosintro proc far
     _textcolor GRAY, BLUE
     call clrscr
     _textcolor YELLOW, BLUE
     _gotoxy 2, 1, 0
     _print frdosmsg, 1
     _textcolor HICYAN, BLUE
     _gotoxy 2, 2, 0
     mov  cx, 17
@@mfr1:
     _echo ''
     loop @@mfr1
      ret
mfrdosintro endp
frdos endp

upgrade proc
 ; fixup mbr

 ; mkdir x:\nxdostmp\
 ; mkdir x:\nxdos
 ; mkdir x:\nxdos\src\
 ; mkdir x:\nxdos\bin\

 ; create a new tmp boot which prompts for recovery disk/files
 ; and uninstalls a botched nxdos install
 ; create recovery disk/files
 ;
 ;if (lpinstall==unistall) {
 ;     createrecoveryfloppy()
 ;   }
 ;createreadme(x:\nxdos\readme.txt)
 ;
 ; copies all files
 ;
 ;copyfiles(x:\nxdos\)
 ;copy nxbio.sys x:\
 ;copy command.com x:\
 ;
 ; if (include_source_code) {
 ;     copy_source_files(x:\nxdos\src\) ; unzip nxdossrc.zip -d x:\ ?
 ;
 ; }
 ;
 ; updates lie table in nxbio.sys

 ; create new autoexec.bat and config.sys

 ;create x:\config.sys
 ;create x:\autoexec.bat
 ;
 ; install new mbr
 ;
 ;writenxdosboot()

 ; change all BPBs on all partitions on all hdds to remove logical sectoring
 ; (do boot partition last)

 ;rmdir x:\nxdostmp\
        ret
upgrade endp

install proc
        _gotoxy 20,6,0
        _textcolor GRAY, BLUE
        _newline
        _print intro, 1
        _newline
        _print cpuisok, 1
        _readkey
        cmp  al, 0
        jne  chkregkey
             _readkey
             cmp  al, 60
             jne  chkf3
                  call frdos
                  jmp  endprog
             chkf3:
             cmp  al, 61
             jne  chkf4

                  jmp  endprog
             chkf4:
             cmp  al, 62
             jne  endprog

                  jmp  endprog
             jmp  endprog
chkregkey:
        cmp  al, 13
        jne  endprog
             call upgrade
endprog:
        _readkey
        ret
install endp

; ===========================================================================
main proc far
; ===========================================================================
     call setup_screen
     call checkhardware
     jnc  computerok
          _newline
          _print oldmsg, 1
          _readkey
          jmp  mainx
computerok:
     ; call get_command_line
     ; mov  si, offset Buffer
     ;if drive = invalid {

     ;} else {
        _gotoxy 20,6,0
        call install
     ;}
mainx:
     _textcolor GRAY, BLACK
     call clrscr
     ret
main endp


setup ends

     end  start
